package intro2java;

/**
 * A simple command line calculator
 *
 * @author Leigh Dodds 
 */
public class Calculator
{
    //public constants
    public static final String PLUS      = "plus";
    public static final String MINUS     = "minus";
    public static final String MULTIPLY  = "times";
    public static final String DIVIDE    = "divide";
    
    //private member variables
    private int x;
    private int y;
    
    /**
     * Creates a calculator initialised with two integers that 
     * the calculator will perform operations on.
     */
    public Calculator(int a, int b)
    {
        x = a;
        y = b;
    }
    
    public int divide()
    {
        return x / y;
    }
    
    public int add()
    {
        return x + y;
    }
    
    public int minus()
    {
        return x - y;
    }
    
    public int multiply()
    {
        return x * y;
    }
    
    public static void main(String[] args)
    {
        //check we have enough parameters
        if (args.length < 3)
        {
            System.out.println("You must supply 3 parameters, e.g. 5 minus 3");
            System.exit(1);
        }
        
        //get the parameters
        int a = Integer.parseInt(args[0]);
        String operation = args[1];
        int b = Integer.parseInt(args[2]);
        
        //create a calculator
        Calculator calculator = new Calculator(a, b);
        
        int result = 0;
        
        //decide which operation to do, and then do it;        
        if (operation.equals(MINUS))
        {
            result = calculator.minus();
        }
        else if (operation.equals(PLUS))
        {
            result = calculator.add();
        }
        else if (operation.equals(DIVIDE))
        {
            result = calculator.divide();
        }
        else if (operation.equals(MULTIPLY))
        {
            result = calculator.multiply();
        }
        else
        {
            System.out.println("Unknown Operation");
            System.exit(1);
        }
        System.out.println("Result: " + result);
        
    }
}
